package fr.username404.snowygui.fabric

import fr.username404.snowygui.gui.feature.Zoom
import net.fabricmc.loader.api.FabricLoader

@JvmField
var isOkZoomerPresent: Boolean = FabricLoader.getInstance().isModLoaded("okzoomer")
private val okZoomerPairs by lazy {
    try {
        with(Class.forName("io.github.joaoh1.okzoomer.client.utils.ZoomUtils")) {
            (getField("zoomDivisor") to null) to (getField("zoomState") to null)
        }
    } catch (e: ClassNotFoundException) {
        with(Class.forName("io.github.ennuil.okzoomer.utils.ZoomUtils").getDeclaredField("zoomerZoom")) {
            get(null).javaClass.run {
                (getDeclaredField("zoomDivisor") to this@with.get(null)) to (getDeclaredField("zoom") to this@with.get(null))
            }
        }
    }.apply { first.first.isAccessible = true; second.first.isAccessible = true; }
}

fun fabricZoom() {
    try {
        with(okZoomerPairs) {
            first.run { first.setDouble(second, Zoom.zoomFactor) }
            second.run { first.setBoolean(second, Zoom.toggled) }
        }
    } catch (e: Exception) {
        isOkZoomerPresent = false
    }
}